unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, ExtCtrls;

type
  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Button6: TButton;
    Pneu: TPanel;
    Edit2: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    edit3: TEdit;
    Edit4: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    edit5: TEdit;
    Button8: TButton;
    Label1: TLabel;
    procedure neukunde;
    procedure array_ausgeben;
    procedure array_speichern;
    procedure array_laden;
    procedure bubblesort;
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

// zunchst muss der Record Tscore im type-Teil deklariert werden :
Tkunde = record
 vorname:string[10];
 nachname:string[30];
 strasse:string[25];
 plzort:string[5];
 knr:integer;
 end;

var
  Form1: TForm1;
  kunden:array of Tkunde; // hinter "array" keine Angaben: dynamisches array: Lnge wird bei Bedarf festgelegt (setlength(Array,Lnge))
  k:file of Tkunde;       // jeder Platz des Arrays besteht nun aus den Einzelteilen von TKunde (vorname, nachname...)
  nr:integer;

implementation

{$R *.DFM}

procedure tform1.neukunde;
begin
setlength(kunden,length(kunden)+1); // Lnge des Array um 1 erhhen
kunden[high(kunden)].vorname:=edit2.text;        // high(array) gibt den hchsten Index im Array an (=letzter Eintrag)
kunden[high(kunden)].nachname:=edit3.text;
kunden[high(kunden)].strasse:=edit4.text;
kunden[high(kunden)].plzort:=edit5.text;
kunden[high(kunden)].knr:=high(kunden);
end;

procedure Tform1.bubblesort;
var i,p:integer;
    buf:Tkunde; // fr den Kreistausch notwendige Hilfsvariable
    a,b:string;
begin
for p:=high(kunden)-1 downto 0 do
for i:=0 to p do
 if kunden[i].knr > kunden[i+1].knr then  // Sortierkriterium sind NUR die Kundennummern
    begin
    buf:=kunden[i];    // sortiert werden aber ganze Array-Stellen (also Tkunden)
    kunden[i]:=kunden[i+1];
    kunden[i+1]:=buf;
    end;
end;

procedure Tform1.array_ausgeben;
var i:integer;
begin
stringgrid1.RowCount:=high(kunden)+2;
for i:=0 to high(kunden) do
    begin
    stringgrid1.cells[0,i+1]:=inttostr(kunden[i].knr);
    stringgrid1.cells[1,i+1]:=kunden[i].vorname;
    stringgrid1.cells[2,i+1]:=kunden[i].nachname;
    stringgrid1.cells[3,i+1]:=kunden[i].strasse;
    stringgrid1.cells[4,i+1]:=kunden[i].plzort;
    end;
end;

procedure Tform1.array_speichern;
var dateiname:string;
    i:integer;
begin
if savedialog1.execute then dateiname := savedialog1.FileName;
  try
  assignfile(k,dateiname);    // Datei einen Festplattenort zuweisen
  rewrite(k);                 // zum Schreiben ffnen
  for i:= 0 to high(kunden) do  // Array indexweise schreiben (Kunde fr Kunde)
  write(k,kunden[i]);
  finally
  closefile(k);                // File schlieen
  end;
end;

procedure Tform1.array_laden;
var dateiname:string;
    i:integer;
begin
setlength(kunden,0);  // Lnge erst mal auf 0 setzen (ist ja noch leer)
if opendialog1.execute then dateiname := opendialog1.FileName;
  try
  assignfile(k,dateiname);  // Datei einen Festplattenort zuweisen
  reset(k);                 // zum Lesen ffnen
  while not eof(k) do
    begin
    setlength(kunden,length(kunden)+1);  // Wichtig: Lnge um 1 erhhen!
    read(k,kunden[high(kunden)]);       // Kundenweise einlesen
    end;
  finally
  closefile(k);                         // schlieen
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
if application.messagebox('Wirklich beenden?','Information',mb_yesno)=id_yes then
close;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
array_ausgeben;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
bubblesort;
array_ausgeben;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
stringgrid1.cells[0,0]:='Kundennummer';
stringgrid1.cells[1,0]:='Vorname';
stringgrid1.cells[2,0]:='Nachname';
stringgrid1.cells[3,0]:='Strae';
stringgrid1.cells[4,0]:='Ort';
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
bubblesort;
array_speichern;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
array_laden;
array_ausgeben;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
pneu.visible:=true;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
neukunde;
pneu.visible:=false;
array_ausgeben;
end;

end.
